// dllmain.cpp : DLL AvP[ṼGg |Cg`܂B
#include "stdafx.h"

BOOL APIENTRY DllMain(HMODULE, DWORD, LPVOID);
void DLLInit();
void ACLiftLimit();

float fACHeightLimit = 800.0f;
// 6D2612
// 6D2623
float fJPHeightLimit = 100.0f;
// 67F25A
// 67F27E
float fACSpeedLimit = 2.25f;
// (m/s / 50.0) ^ 2
// 6DADDD
float fACSpeedMulti = 1.5f;
// m/s / 50.0
// 6DADED
// 6DADF6
// 6DADFF
bool bACLiftLimit = true;
// 6D977D

unsigned long dwAMLockonDelay = 1500;
// 6E3638
// 6E36F9
unsigned long dwSMLockonDelay = 1500;
// 512099

unsigned long dwGunRateHunter = 60;
// 6D41BA
unsigned long dwGunRateSeaspar = 40;
// 6D4147
unsigned long dwGunRateRustler = 80;
// 6D415E
unsigned long dwGunRateHydra = 17;
// 6D4175
unsigned long dwGunRateCargobob = 100;
// 6D41A3

unsigned long dwGunTypeHunter = 36;
// 6D4DE2
unsigned long dwGunTypeRustler = 31;
// 6D4DB7
unsigned long dwGunTypeNormal = 31;
// 6D4D8E

unsigned long dwRhinoCannonReload = 800;
// 6AED0E
unsigned long dwHunterRocketReload = 500;
// 6D45F1
unsigned long dwSeasparRocketReload = 1000;
// 6D460A
unsigned long dwHydraRocketReload = 500;
// 6D462C
// 6D4632
unsigned long dwHydraFlareReload = 2000;
// 6E3519

float fNPCHydraRangeL = 160.0f;
// 429691
float fNPCHydraRangeS = 30.0f;
// 4296A2
float fNPCHydraRangeA = 0.8f;
// 4296DA
unsigned long dwNPCHydraMissileRate = 2000;
// 0x100000000 / ms * 128
// 429641
// 429668

float fSAMRangeL = 120.0f;
// 5A0A83
float fSAMRangeS = 0.1f;
// 5A0AAB
unsigned long dwSAMRate = 4000;
// 0x100000000 / ms * 256
// 5A0ABC
// 5A0AC9

#define patch(a, v, s) _patch((void*)(a), (void*)(v), (s))
void _patch(void*, void*, int);
#define nop(a, s) _nop((void*)(a), (s))
void _nop(void*, int);
bool check(void*, unsigned char, const char*, bool);
bool _check(void*, unsigned char);

BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		DLLInit();
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}

void DLLInit()
{
	char cPath[MAX_PATH];
	char cBuffer[64];
	void* pPatch;

	GetModuleFileName(NULL, cPath, MAX_PATH);
	if (strrchr(cPath, '\\')) *(char*)strrchr(cPath, '\\') = '\0';
	strcat_s(cPath, MAX_PATH, "\\airlimit.ini");

	if (check((void*)0x6D2612, 0xD8, "Physical - ACHeight", false))
	{
		GetPrivateProfileString("Physical", "ACHeight", "800.0", cBuffer, 64, cPath);
		fACHeightLimit = (float)atof(cBuffer);
		pPatch = &fACHeightLimit;
		patch(0x6D2614, &pPatch, 4);
		patch(0x6D2625, &pPatch, 4);
	}
	if (check((void*)0x67F25A, 0xD8, "Physical - JPHeight", false))
	{
		GetPrivateProfileString("Physical", "JPHeight", "100.0", cBuffer, 64, cPath);
		fJPHeightLimit = (float)atof(cBuffer);
		pPatch = &fJPHeightLimit;
		patch(0x67F25C, &pPatch, 4);
		patch(0x67F280, &pPatch, 4);
	}
	if (check((void*)0x6DADDD, 0xD8, "Physical - ACSpeed", false))
	{
		GetPrivateProfileString("Physical", "ACSpeed", "75.0", cBuffer, 64, cPath);
		fACSpeedMulti = (float)(atof(cBuffer) / 50.0);
		fACSpeedLimit = fACSpeedMulti * fACSpeedMulti;
		pPatch = &fACSpeedLimit;
		patch(0x6DADDF, &pPatch, 4);
		pPatch = &fACSpeedMulti;
		patch(0x6DADEF, &pPatch, 4);
		patch(0x6DADF8, &pPatch, 4);
		patch(0x6DAE01, &pPatch, 4);
	}
	if (check((void*)0x6D9777, 0xD8, "Physical - ACLift", false))
	{
		bACLiftLimit = GetPrivateProfileInt("Physical", "ACLift", 1, cPath) != 0;
		if (bACLiftLimit)
		{
			unsigned char cJump = 0xE9;
			unsigned long pFunc = (unsigned long)&ACLiftLimit - 0x6D977C;
			patch(0x6D9777, &cJump, 4);
			patch(0x6D9778, &pFunc, 4);
		}
	}

	if (check((void*)0x6E3638, 0x81, "LockOn - AMDelay", false))
	{
		dwAMLockonDelay = GetPrivateProfileInt("LockOn", "AMDelay", 1500, cPath);
		patch(0x6E363A, &dwAMLockonDelay, 4);
		patch(0x6E36FB, &dwAMLockonDelay, 4);
	}
	if (check((void*)0x512099, 0x81, "LockOn - SMDelay", false))
	{
		dwSMLockonDelay = GetPrivateProfileInt("LockOn", "SMDelay", 1500, cPath);
		patch(0x51209B, &dwSMLockonDelay, 4);
	}

	if (check((void*)0x6D41BA, 0xC7, "GunRate - Hunter", false))
	{
		dwGunRateHunter = GetPrivateProfileInt("GunRate", "Hunter", 60, cPath);
		patch(0x6D41BE, &dwGunRateHunter, 4);
	}
	if (check((void*)0x6D4147, 0xC7, "GunRate - Seaspar", false))
	{
		dwGunRateSeaspar = GetPrivateProfileInt("GunRate", "Seaspar", 40, cPath);
		patch(0x6D414B, &dwGunRateSeaspar, 4);
	}
	if (check((void*)0x6D415E, 0xC7, "GunRate - Rustler", false))
	{
		dwGunRateRustler = GetPrivateProfileInt("GunRate", "Rustler", 80, cPath);
		patch(0x6D4162, &dwGunRateRustler, 4);
	}
	if (check((void*)0x6D4175, 0xC7, "GunRate - Hydra", false))
	{
		dwGunRateHydra = GetPrivateProfileInt("GunRate", "Hydra", 17, cPath);
		patch(0x6D4179, &dwGunRateHydra, 4);
	}
	if (check((void*)0x6D41A3, 0xC7, "GunRate - Cargobob", false))
	{
		dwGunRateCargobob = GetPrivateProfileInt("GunRate", "Cargobob", 100, cPath);
		patch(0x6D41A7, &dwGunRateCargobob, 4);
	}
	
	if (check((void*)0x6D4DE2, 0xBF, "GunType - Hunter", false))
	{
		dwGunTypeHunter = GetPrivateProfileInt("GunType", "Hunter", 36, cPath);
		patch(0x6D4DE3, &dwGunTypeHunter, 4);
	}
	if (check((void*)0x6D4DB7, 0xBF, "GunType - Rustler", false))
	{
		dwGunTypeRustler = GetPrivateProfileInt("GunType", "Rustler", 31, cPath);
		patch(0x6D4DB8, &dwGunTypeRustler, 4);
	}
	if (check((void*)0x6D4D8E, 0xBF, "GunType - Normal", false))
	{
		dwGunTypeNormal = GetPrivateProfileInt("GunType", "Normal", 31, cPath);
		patch(0x6D4D8F, &dwGunTypeNormal, 4);
	}
	
	if (check((void*)0x6AED0E, 0x81, "Reload - RhinoCannon", false))
	{
		dwRhinoCannonReload = GetPrivateProfileInt("Reload", "RhinoCannon", 800, cPath);
		patch(0x6AED10, &dwRhinoCannonReload, 4);
	}
	if (check((void*)0x6D45F1, 0xC7, "Reload - HunterRocket", false))
	{
		dwHunterRocketReload = GetPrivateProfileInt("Reload", "HunterRocket", 500, cPath);
		patch(0x6D45F5, &dwHunterRocketReload, 4);
	}
	if (check((void*)0x6D460A, 0xC7, "Reload - SeasparRocket", false))
	{
		dwSeasparRocketReload = GetPrivateProfileInt("Reload", "SeasparRocket", 1000, cPath);
		patch(0x6D460E, &dwSeasparRocketReload, 4);
	}
	if (check((void*)0x6D462C, 0x81, "Reload - HydraRocket", false))
	{
		dwHydraRocketReload = GetPrivateProfileInt("Reload", "HydraRocket", 500, cPath);
		patch(0x6D462E, &dwHydraRocketReload, 4);
		patch(0x6D4634, &dwHydraRocketReload, 4);
	}
	if (check((void*)0x6E3519, 0x81, "Reload - HydraFlare", false))
	{
		dwHydraFlareReload = GetPrivateProfileInt("Reload", "HydraFlare", 2000, cPath);
		patch(0x6E351B, &dwHydraFlareReload, 4);
	}
	
	if (check((void*)0x429691, 0xD8, "NPCHydra - RangeL", false))
	{
		GetPrivateProfileString("NPCHydra", "RangeL", "160.0", cBuffer, 64, cPath);
		fNPCHydraRangeL = (float)atof(cBuffer);
		pPatch = &fNPCHydraRangeL;
		patch(0x429693, &pPatch, 4);
	}
	if (check((void*)0x4296A2, 0xD8, "NPCHydra - RangeS", false))
	{
		GetPrivateProfileString("NPCHydra", "RangeS", "30.0", cBuffer, 64, cPath);
		fNPCHydraRangeS = (float)atof(cBuffer);
		pPatch = &fNPCHydraRangeS;
		patch(0x4296A4, &pPatch, 4);
	}
	if (check((void*)0x4296DA, 0xD8, "NPCHydra - RangeA ", false))
	{
		GetPrivateProfileString("NPCHydra", "RangeA", "36.87", cBuffer, 64, cPath);
		fNPCHydraRangeA = (float)cos(min(max(atof(cBuffer), 0.0), 180.0) * M_PI / 180.0);
		pPatch = &fNPCHydraRangeA;
		patch(0x4296DC, &pPatch, 4);
	}
	if (check((void*)0x429641, 0xB8, "NPCHydra - Rate", false))
	{
		dwNPCHydraMissileRate = (unsigned long)(4294967296.0 / (double)GetPrivateProfileInt("NPCHydra", "Rate", 2000, cPath) * 128.0);
		patch(0x429642, &dwNPCHydraMissileRate, 4);
		patch(0x429669, &dwNPCHydraMissileRate, 4);
	}
	
	if (check((void*)0x5A0A83, 0xD8, "SAM - RangeL", false))
	{
		GetPrivateProfileString("SAM", "RangeL", "120.0", cBuffer, 64, cPath);
		fSAMRangeL = (float)atof(cBuffer);
		pPatch = &fSAMRangeL;
		patch(0x5A0A85, &pPatch, 4);
	}
	if (check((void*)0x5A0AAB, 0xD8, "SAM - RangeS", false))
	{
		GetPrivateProfileString("SAM", "RangeS", "0.1", cBuffer, 64, cPath);
		fSAMRangeS = (float)atof(cBuffer);
		pPatch = &fSAMRangeS;
		patch(0x5A0AAD, &pPatch, 4);
	}
	if (check((void*)0x5A0ABC, 0xB8, "SAM - Rate", false))
	{
		dwSAMRate = (unsigned long)(4294967296.0 / (double)GetPrivateProfileInt("SAM", "Rate", 4000, cPath) * 256.0);
		patch(0x5A0ABD, &dwSAMRate, 4);
		patch(0x5A0ACA, &dwSAMRate, 4);
	}
	
	return;
}

const float fMaxSpeed = 2.25f;
void __declspec(naked) ACLiftLimit()
{
	__asm
	{
		push eax;
		mov eax, 0xB7CB5C;
		fmul dword ptr [eax];
		fld dword ptr [esp + 0x1C];
		fcomp fMaxSpeed;
		fstsw ax;
		test ah, 0x41;
		jnz LIFT_TRUE;
		fmul dword ptr fMaxSpeed;
		jmp LIFT_RETURN;
LIFT_TRUE:
		fmul dword ptr [esp + 0x1C];
LIFT_RETURN:
		pop eax;
		push 0x6D9781;
		ret;
	}
}

void _patch(void* pAddress, void* pData, int iSize)
{
	unsigned long dwProtect[2];
	VirtualProtect(pAddress, iSize, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	memcpy(pAddress, pData, iSize);
	VirtualProtect(pAddress, iSize, dwProtect[0], &dwProtect[1]);
}

void _nop(void* pAddress, int iSize)
{
	unsigned long dwProtect[2];
	VirtualProtect(pAddress, iSize, PAGE_EXECUTE_READWRITE, &dwProtect[0]);
	memset(pAddress, 0x90, iSize);
	VirtualProtect(pAddress, iSize, dwProtect[0], &dwProtect[1]);
}

bool check(void* pAddress, unsigned char cByte, const char* sExp, bool bContinue)
{
	if (_check(pAddress, cByte)) return true;
	if (bContinue) return false;
	char buf[1024];
	sprintf_s(buf, 1024, "An unknown code found at 0x%08X (%s).\nDo you want to continue without this Function?", pAddress, sExp);
	if (MessageBox(0, buf, "Virtual IMG", MB_YESNO | MB_ICONERROR | MB_DEFBUTTON2) == IDNO) ExitProcess(0);
	return false;
}

bool _check(void* pAddress, unsigned char cByte)
{
	unsigned long dwProtect[2];
	unsigned char cValue = cByte;
	VirtualProtect(pAddress, 1, PAGE_EXECUTE_READ, &dwProtect[0]);
	memcpy(&cValue, pAddress, 1);
	VirtualProtect(pAddress, 1, dwProtect[0], &dwProtect[1]);
	return (cValue == cByte);
}
